/*----------------------------------------------------------------------+
|									|
|  Copyright (c) 1985-95;  Bentley Systems, Inc., All rights reserved.	|
|									|
| "MicroStation", "MDL", and "MicroCSL" are trademarks of Bentley	|
|  Systems, Inc.							|
|									|
|  Limited permission is hereby granted to reproduce and modify this	|
|  copyrighted material provided that the resulting code is used only 	|
|  in conjunction with Bentley Systems products under the terms of the	|
|  license agreement provided therein, and that this notice is retained	|
|  in its entirety in any such reproduction or modification.		|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|   $Workfile:   rtypes.h  $
|   $Revision:   6.35  $
|      	$Date:   12 Dec 1995 18:07:50  $
|									|
+----------------------------------------------------------------------*/
#ifndef __rtypesH__
#define __rtypesH__

/*----------------------------------------------------------------------+
|									|
|  NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE!	|
|  NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE!	|
|  NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE! NOTE!	|
|									|
|  BSI uses mixed case in all it's resourceclass ids. If you want to	|
|  ensure uniqueness between your ids and all current and		|
|  future BSI ids, make sure you use all upper or all lower case	|
|  characters in your character constants.				|
|									|
|  EXCEPTIONS: str#,dilt,cmnd,gnrc,labl,levm,list,sash,scle,sepr,syns	|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|  Internal Microstation Resource Type Identifiers   			|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_MESSAGES		    RTYPE( 's','t','r','#' )
#define RTYPE_STRINGLIST	    RTYPE( 's','t','r','L' )
#define RTYPE_CharString	    RTYPE( 'C','h','r','#' )
#define RTYPE_ExtAttrList	    RTYPE( 'x','A','t','L' )
#define RTYPE_COMMAND		    RTYPE( 'C','m','d','s' )
#define RTYPE_COMMANDTABLE	    RTYPE( 'C','m','d','T' )
#define RTYPE_EXTCOMMANDTABLE	    RTYPE( 'C','m','d','X' )
#define RTYPE_CMDNAME		    RTYPE( 'C','m','d','N' )
#define RTYPE_ERRMSGS		    RTYPE( 'E','r','r','s' )
#define RTYPE_XLATE		    RTYPE( 'X','l','a','t' )
#define RTYPE_UCMVAR		    RTYPE( 'U','c','m','V' )
#define RTYPE_CHARXLT		    RTYPE( 'C','X','l','t' )

/* USCONFIG and USINSTAL Types */
#define RTYPE_CNFGDATA		    RTYPE( 'C','n','f','D' )
#define RTYPE_CNFGMENU		    RTYPE( 'C','n','f','M' )

/* Database Server Types. */
#define RTYPE_DBCOMMAND		    RTYPE( 'D','B','C','d' )
#define RTYPE_DBTYPE		    RTYPE( 'D','B','T','y' )

/* MDL Types. */
#define RTYPE_MDLDBGCMD		    RTYPE( 'M','d','l','D' )
#define RTYPE_MDLIMAGE		    RTYPE( 'M','d','l','I' )

/* C Expression Evaluation */
#define RTYPE_CMEMBER		    RTYPE( 'C','E','m','e' )
#define RTYPE_CNAME		    RTYPE( 'C','E','n','a' )
#define	RTYPE_CSTRUCT_NAME	    RTYPE( 'C','E','s','t' )
#define RTYPE_CTYPE		    RTYPE( 'C','E','t','y' )

/* General items. */
#define RTYPE_INTEGER		    RTYPE( 'I','n','t','g' )

/* MicroStation Symbol Table */
#define RTYPE_USTNSYMBOLS	    RTYPE( 'U','s','t','S' )

/* MicroStation Symbol Table */
#define RTYPE_AliasList		    RTYPE( 'A','l','i','a' )

/*----------------------------------------------------------------------+
|									|
|   Standard Dialog Resource Types        				|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_DialogBox		    RTYPE( 'd','B','o','x' )
#define RTYPE_DialogItemList	    RTYPE( 'd','i','l','t' )
#define RTYPE_ItemList		    RTYPE( 'i','L','s','t' )
#define RTYPE_IdList		    RTYPE( 'i','d','s','L' )
#define RTYPE_ResourceDescr	    RTYPE( 'r','s','D','s' )
#define RTYPE_DialogPosition	    RTYPE( 'd','P','o','s' )
#define RTYPE_DialogPositionX	    RTYPE( 'd','P','s','X' )
#define RTYPE_PalettePosition	    RTYPE( 'P','P','o','s' )

#define RTYPE_KeyinSaveArea	    RTYPE( 'K','S','a','v' )
#define RTYPE_HookFunction	    RTYPE( 'h','F','n','c' )
#define RTYPE_BasicProgramEditor    RTYPE( 'b','P','E',' ' )
#define RTYPE_BasicCodeResource	    RTYPE( 'b','C','o','d' )
#define RTYPE_BasicCodeStamp	    RTYPE( 'b','T','i','m' )
#define RTYPE_BasicDebugPrefs	    RTYPE( 'b','D','b','P' )
#define RTYPE_BasicEntryElmUpdate   RTYPE( 'b','E','E','U' )
#define RTYPE_BasicEntryJustHdr     RTYPE( 'b','H','d','r' )
/* "Basic Extensions Version" resource type - stored inside MBE1.MA */
#define RTYPE_BasicExtVersion	    RTYPE( 'b','E','x','V' )

#define RTYPE_ButtonGroup	    RTYPE( 'b','G','r','p' )
#define RTYPE_CheckButton	    RTYPE( 'c','B','t','n' )
#define RTYPE_ColorPicker	    RTYPE( 'c','P','c','k' )
#define RTYPE_Command		    RTYPE( 'c','m','n','d' )
#define RTYPE_CmdItemList	    RTYPE( 'C','I','L','i' )
#define RTYPE_Generic		    RTYPE( 'g','n','r','c' )
#define RTYPE_GroupBox		    RTYPE( 'g','B','o','x' )
#define RTYPE_IconEditor	    RTYPE( 'i','c','n','E' )
#define RTYPE_IconCmd		    RTYPE( 'i','C','m','d' )
#define RTYPE_IconCmdX		    RTYPE( 'i','C','m','X' )
#define RTYPE_IconCmdSmallIcon	    RTYPE( 'i','C','S','m' )
#define RTYPE_IconCmdLargeIcon	    RTYPE( 'i','C','L','g' )
#define RTYPE_IconCmdPalette	    RTYPE( 'i','P','a','l' )
#define RTYPE_IconCmdPaletteX	    RTYPE( 'i','P','l','X' ) /* Create only */
#define RTYPE_IconCmdFrame	    RTYPE( 'i','F','r','m' )
#define RTYPE_IconCmdFrameX	    RTYPE( 'i','F','m','X' ) /* Create Only */
#define RTYPE_Label		    RTYPE( 'l','a','b','l' )
#define RTYPE_LevelMap		    RTYPE( 'l','e','v','m' )
#define RTYPE_LevelPicker	    RTYPE( 'l','P','c','k' )
/*  RTYPE_List is obsolete. Do not use it. */
#define RTYPE_List		    RTYPE( 'l','i','s','t' )
#define RTYPE_ListBox		    RTYPE( 'l','B','o','x' )
#define RTYPE_MenuBar		    RTYPE( 'm','B','a','r' )
#define RTYPE_MenuBarX		    RTYPE( 'm','B','r','X' )
#define RTYPE_MultilineText	    RTYPE( 'm','T','x','t' )
#define RTYPE_OptionButton 	    RTYPE( 'o','B','t','n' )
/*  RTYPE_PopupMenu is obsolete. Do not use it. */
#define RTYPE_PopupMenu 	    RTYPE( 'p','M','e','n' )
#define RTYPE_PrecisionButton	    RTYPE( 'p','r','c','B' )
#define RTYPE_PulldownMenu	    RTYPE( 'p','d','M','n' )
#define RTYPE_PulldownMenuX	    RTYPE( 'p','d','M','X' )   /* Create only */
#define RTYPE_PulldownOptionMenu    RTYPE( 'p','d','O','M' )
#define RTYPE_PulldownCPickerMenu   RTYPE( 'p','d','C','M' )
#define RTYPE_PulldownTextMenuItem  RTYPE( 'p','d','T','I' )
#define RTYPE_PushButton	    RTYPE( 'p','B','t','n' )
#define RTYPE_RadioButton	    RTYPE( 'r','B','t','n' )
#define RTYPE_RadioButtonList	    RTYPE( 'r','B','l','s' )
#define RTYPE_Sash		    RTYPE( 's','a','s','h' )
#define RTYPE_Scale		    RTYPE( 's','c','l','e' )
#define RTYPE_ScrollBar		    RTYPE( 's','B','a','r' )
#define RTYPE_Separator		    RTYPE( 's','e','p','r' )
#define RTYPE_Synonyms  	    RTYPE( 's','y','n','s' )
#define RTYPE_TabFolder		    RTYPE( 'T','a','b','F' )
#define RTYPE_Text		    RTYPE( 'd','T','x','t' )
#define RTYPE_ToolBox		    RTYPE( 't','B','o','x' )
#define RTYPE_ToggleButton	    RTYPE( 't','B','t','n' )
#define RTYPE_WindowMenu	    RTYPE( 'w','M','e','n' )

#define	RTYPE_Icon		    RTYPE( 'I','c','o','n' )
#define RTYPE_StringArray	    RTYPE( 's','t','r','A' )

#define RTYPE_VirtualKeyTable	    RTYPE( 'v','T','b','l' )
#define RTYPE_AcceleratorKeyTable   RTYPE( 'a','T','b','l' )
#define	RTYPE_RunTimeConfig	    RTYPE( 'r','t','C','f' ) /* req'd for MSC */

/* database dialog resource types - see dbdialog.h */
#define RTYPE_DatabaseTableBox	    RTYPE( 'd','b','T','b' )

/* font resource types - see fontrsrc.h */
#define RTYPE_FontDefault	    RTYPE( 'f','t','D','F' )
#define RTYPE_FontFamily	    RTYPE( 'f','t','F','M' )

#define RTYPE_FontName		    RTYPE( 'f','t','N','M' )
#define RTYPE_FontLibrary	    RTYPE( 'f','t','L','B' )
#define RTYPE_FontHeader	    RTYPE( 'f','t','H','D' )
#define RTYPE_FontCharacters	    RTYPE( 'f','t','C','H' )
#define RTYPE_FontVectors	    RTYPE( 'f','t','V','C' )
#define RTYPE_FontVectorOffsets     RTYPE( 'f','t','V','O' )
#define RTYPE_FontGlyphs	    RTYPE( 'f','t','G','L' )
#define RTYPE_FontGlyphOffsets      RTYPE( 'f','t','G','O' )
#define RTYPE_FontRange		    RTYPE( 'f','t','B','R' )
#define RTYPE_FontKerning	    RTYPE( 'f','t','K','R' )
#define RTYPE_FontLigature	    RTYPE( 'f','t','L','G' )
#define RTYPE_FontFractions	    RTYPE( 'f','t','F','R' )
#define RTYPE_FontUnicodeMap	    RTYPE( 'f','t','U','M' )
#define RTYPE_FontImporterVersion   RTYPE( 'f','t','I','V' )
#define RTYPE_FontCharacterMap	    RTYPE( 'f','t','C','M' )

/* text editor preferences - see textedit.h */
#define RTYPE_TextEditPrefs	    RTYPE( 't','e','P','R' )
#define RTYPE_TextEditUnicodeInfo   RTYPE( 't','e','U','I' )

/* text editor preferences - see textedit.h */
#define RTYPE_FontInstPrefs	    RTYPE( 'f','i','P','R' )

/* Data Definition Resource Types. */
#define RTYPE_DataDefBlock	    RTYPE( 'd','D','e','f' )
#define RTYPE_DataSize		    RTYPE( 'd','S','i','z' )

/* TParse State Resource Type */
#define RTYPE_TPARSESTATE	    RTYPE( 'T','P','S','t' )

/* overall window position, windows 32 */
#define RTYPE_OverallWindowPosition RTYPE( 'o','P','o','s' )

/* Dimension style type */
#define RTYPE_Dimension		    RTYPE( 'S','t','D','M' )

/* Multiline style type */
#define RTYPE_Multiline		    RTYPE( 'S','t','M','L' )

/* IGES translator resource constants  */
#define RTYPE_IGESConstants	    RTYPE( 'I','G','S','c' )
#define RTYPE_IGESOutPrefs	    RTYPE( 'I','G','O','p' )
#define RTYPE_IGESInPrefs	    RTYPE( 'I','G','I','p' )
#define RTYPE_IGESLevelMap	    RTYPE( 'l','M','a','p' )
#define RTYPE_IGESFontMap	    RTYPE( 'f','M','a','p' )
#define RTYPE_IGESCellMap	    RTYPE( 'c','M','a','p' )
#define RTYPE_IGESCharMap	    RTYPE( 'c','h','r','M' )
#define RTYPE_IGESIntList	    RTYPE( 'I','G','i','a' )


/*----------------------------------------------------------------------+
|									|
|   Line Style Resource Types						|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_LineStyle		    RTYPE( 'l','s','L','S' )
#define RTYPE_LineCode		    RTYPE( 'l','s','L','C' )
#define RTYPE_LinePoint		    RTYPE( 'l','s','L','P' )
#define RTYPE_PointSym		    RTYPE( 'l','s','P','S' )
#define RTYPE_LineStyleNames	    RTYPE( 'l','s','N','M' )

/*----------------------------------------------------------------------+
|									|
|   Save Image Resource Types						|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_SaveImage		    RTYPE( 's','v','I','M' )

/*----------------------------------------------------------------------+
|									|
|   Command Browser Resource Types					|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_CmdBrowser	    RTYPE( 'c','M','D','b' )

/*----------------------------------------------------------------------+
|									|
|   Color Types								|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_ColorDescr	    RTYPE( 'C','D','s','c' )
#define RTYPE_XColorArray	    RTYPE( 'X','c','l','r' )
#define RTYPE_ExactColorFlags	    RTYPE( 'E','x','F','l' )
#define RTYPE_ColorDefArray	    RTYPE( 'C','d','f','A' )
#define RTYPE_ColorDefStringList    RTYPE( 'C','d','f','L' )
#define RTYPE_ColorDefVersion       RTYPE( 'C','d','f','V' )
#define RTYPE_ColorDefDefault       RTYPE( 'C','d','f','D' )

/*----------------------------------------------------------------------+
|									|
|   Version Resource Type						|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_Version		    RTYPE( 'U','v','e','r' )

/*----------------------------------------------------------------------+
|									|
|   User Pref Resources							|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_USERPREFS		    RTYPE( 'U','p','r','f' )
#define RTYPE_ButtonMap		    RTYPE( 'B','t','n','M' )
#define RTYPE_LineWeightMap	    RTYPE( 'L','w','t','M' )
#define RTYPE_DgnAppStartUp	    RTYPE( 'D','S','t','U' )
#define RTYPE_FileName		    RTYPE( 'F','i','l','N' )
#define RTYPE_XBorderInfo	    RTYPE( 'X','B','r','d' )
#define RTYPE_TrackArea		    RTYPE( 'T','r','c','k' )
#define RTYPE_NewTrackArea	    RTYPE( 'N','t','r','k' )
#define	RTYPE_PreviewDlogSize       RTYPE( 'P','r','v','S' )

/*----------------------------------------------------------------------+
|								    	|
|   Cell Selector Preference Resource Type			    	|
|								    	|
+----------------------------------------------------------------------*/
#define RTYPE_CellSelectorPrefs     RTYPE('c','S','p','F' )

/*----------------------------------------------------------------------+
|								    	|
|   Configuration Variable Resource Type			    	|
|								    	|
+----------------------------------------------------------------------*/
#define RTYPE_CfgVarList	    RTYPE('c','f','g','V')

/*----------------------------------------------------------------------+
|									|
|   MicroStation Extended TCB Ids (and version-specific data def ids)	|
|									|
|   Although extended tcbs will never be saved as resources, their ids  |
|   are defined here to ensure uniqueness for their associated		|
|   data definition ids.						|
|									|
+----------------------------------------------------------------------*/
#define MSTCBID_ToolSettings		RTYPE( 'T','c','T','o' )
#define DataDefID_ToolSettings_V0       RTYPE( 'd','T','o','0' )
#define DataDefID_ToolSettings_V1       RTYPE( 'd','T','o','1' )
#define DataDefID_ToolSettings_V2       RTYPE( 'd','T','o','2' )

#define MSTCBID_3DToolSettings		RTYPE( 'T','c','3','D' )
#define DataDefID_3DToolSettings_V0     RTYPE( 'd','3','D','0' )
#define DataDefID_3DToolSettings_V1     RTYPE( 'd','3','D','1' )

#define MSTCBID_RenderSettings		RTYPE( 'T','c','R','e' )
#define DataDefID_RenderSettings_V0     RTYPE( 'd','R','e','0' )
#define DataDefID_RenderSettings_V1     RTYPE( 'd','R','e','1' )
#define DataDefID_RenderSettings_V2     RTYPE( 'd','R','e','2' )

#define MSTCBID_LStyleSettings		RTYPE( 'T','c','L','s' )
#define DataDefID_LStyleSettings_V0     RTYPE( 'd','L','s','0' )
#define DataDefID_LStyleSettings_V1     RTYPE( 'd','L','s','1' )
#define DataDefID_LStyleSettings_V2     RTYPE( 'd','L','s','2' )

#define MSTCBID_ModelerSettings		RTYPE( 'T','c','M','m' )
#define DataDefID_ModelerSettings_V0    RTYPE( 'd','M','m','0' )
#define DataDefID_ModelerSettings_V1    RTYPE( 'd','M','m','1' )

#define MSTCBID_MpieceSettings		RTYPE( 'T','c','M','p' )
#define DataDefID_MpieceSettings_V0	RTYPE( 'd','M','p','0' )

#define MSTCBID_TextSettings		RTYPE( 'T','c','T','x' )
#define DataDefID_TextSettings_V0       RTYPE( 'd','T','x','0' )
#define DataDefID_TextSettings_V1       RTYPE( 'd','T','x','1' )
#define DataDefID_TextSettings_V2       RTYPE( 'd','T','x','2' )

#define MSTCBID_UpdateSequence  	RTYPE( 'T','c','U','x' )
#define DataDefID_UpdateSequence_V0     RTYPE( 'd','U','S','0' )
	    
#define MSTCBID_DrawCompSettings  	RTYPE( 'T','c','D','x' )
#define DataDefID_DrawCompSettings_V0   RTYPE( 'd','D','S','0' )

/*----------------------------------------------------------------------+
|									|
|   Tags Types							    	|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_Tags_SetDefinition     RTYPE( 'T','g','L','b' )

/*----------------------------------------------------------------------+
|									|
|   DWGin/out Types							|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_DWGInPrefs	    	RTYPE( 'D','G','I','p' )
#define RTYPE_DWGOutPrefs	    	RTYPE( 'D','G','O','p' )
#define RTYPE_DWGOutMorePrefs       	RTYPE( 'D','M','O','p' )
#define RTYPE_DWGLineType	    	RTYPE( 'D','B','L','t' )

/*----------------------------------------------------------------------+
|									|
|   Geomtol Types							|
|									|
+----------------------------------------------------------------------*/
#define RTYPE_GeomTol		    	RTYPE( 'g','E','o','M' )

/*----------------------------------------------------------------------+
|									|
|   Macros								|
|									|
+----------------------------------------------------------------------*/
#if defined (rm286)
#define RTYPE( c1, c2, c3, c4 )	(((((((unsigned long)(c1)<<8)|c2)<<8)|c3)<<8)|c4)
#else
#define RTYPE( c1, c2, c3, c4 )	(((((((c1)<<8)|c2)<<8)|c3)<<8)|c4)
#endif

#endif /* defined __rtypesH__ */
